> ## Documentation Index
> Fetch the complete documentation index at: https://docs.solvice.io/llms.txt
> Use this file to discover all available pages before exploring further.

# Fill Solution

> Contains the actual solution, once solved.



## OpenAPI

````yaml fill GET /v2/fill/jobs/{id}/solution
openapi: 3.1.0
info:
  description: |2-

                Welcome to the Solvice API! You can use our API to access Solvice API endpoints,
                which can get information on your solved jobs,
                their statuses and of course post new solve jobs.
            
  title: FILL API
  version: '2.0'
servers:
  - url: https://api.solvice.io
    description: Production API
security:
  - apikey: []
tags:
  - name: FILL API
    description: FILL API
paths:
  /v2/fill/jobs/{id}/solution:
    get:
      tags:
        - Info
      summary: Solution
      description: Contains the actual solution, once solved.
      operationId: getFillSolution
      parameters:
        - name: id
          in: path
          required: true
          schema:
            type: string
      responses:
        '200':
          description: OK
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/FillResponse'
components:
  schemas:
    FillResponse:
      type: object
      description: Fill response from solve
      properties:
        id:
          type:
            - string
            - 'null'
          examples:
            - 0000-00000-00000-0000
          description: Id of the solve job
        status:
          type:
            - string
            - 'null'
          examples:
            - SOLVED
          description: Status of the Response
          anyOf:
            - $ref: '#/components/schemas/SolviceStatus'
            - type: 'null'
        score:
          type:
            - object
            - 'null'
          description: Score tells you how good a solution is.
          anyOf:
            - $ref: '#/components/schemas/Score'
            - type: 'null'
        assignments:
          type:
            - array
            - 'null'
          items:
            $ref: '#/components/schemas/ShiftAssignmentSolution'
          description: 'Actual solution: assignments per shift'
        unassigned:
          type:
            - array
            - 'null'
          examples:
            - '[shift-1]'
          items:
            type: string
          description: Unassigned shifts
        suggestions:
          type:
            - array
            - 'null'
          items:
            $ref: '#/components/schemas/ShiftAssignmentSolution'
          description: List of suggested shift assignments returned by suggest api call
        violations:
          type:
            - array
            - 'null'
          items:
            $ref: '#/components/schemas/ViolatedConstraint'
    SolviceStatus:
      type: string
      enum:
        - ERROR
        - QUEUED
        - SOLVING
        - SOLVED
      description: Status of the solve job.
    Score:
      type: object
      description: >-
        The score of a solution shows how good this solution is w.r.t all the
        constraints. All solvers try to maximize the score.
      properties:
        hardScore:
          type:
            - integer
            - 'null'
          format: int64
          description: >-
            The score of the constraints that are hard. This should be 0 in
            order to be feasible.
        mediumScore:
          type:
            - integer
            - 'null'
          format: int64
          description: The score of the constraints that are medium.
        softScore:
          type:
            - integer
            - 'null'
          format: int64
          description: The score of the constraints that are soft.
        feasible:
          type:
            - boolean
            - 'null'
    ShiftAssignmentSolution:
      type: object
      required:
        - shift
        - from
        - to
      description: Shift assignment solution
      properties:
        shift:
          type: string
          examples:
            - shift-1
          description: Shift id
        from:
          $ref: '#/components/schemas/LocalDateTime'
          type: string
          examples:
            - 2021-01-01T08:00
          description: Start date-time
        to:
          $ref: '#/components/schemas/LocalDateTime'
          type: string
          examples:
            - 2021-01-01T08:00
          description: End date-time
        skills:
          type:
            - array
            - 'null'
          examples:
            - '[skill-1, skill-2]'
          items:
            type: string
          description: List of skills
        employee:
          type:
            - string
            - 'null'
          examples:
            - employee-1
          description: Employee id
        travelTimeInSeconds:
          type:
            - integer
            - 'null'
          format: int64
          examples:
            - 123
          description: Travel time in seconds
    ViolatedConstraint:
      type: object
      required:
        - name
        - value
        - level
      description: >-
        A constraint that is broken in the current solution with a certain value
        (penalty) and a certain level (hard, soft, medium).
      properties:
        name:
          type:
            - string
            - 'null'
          examples:
            - maxDistance
          description: Name of the constraint.
        value:
          type:
            - integer
            - 'null'
          format: int32
          examples:
            - 100
          description: >-
            Value of the unresolved constraint. The higher, the more deviation
            from perfection this constraint has.
        level:
          type:
            - string
            - 'null'
          examples:
            - '[HARD, MEDIUM, SOFT]'
          description: Level of unresolved constraint.
          anyOf:
            - $ref: '#/components/schemas/Level'
            - type: 'null'
    LocalDateTime:
      type: string
      format: date-time
      examples:
        - '2022-03-10T12:15:50'
    Level:
      type: string
      enum:
        - HARD
        - SOFT
        - MEDIUM
  securitySchemes:
    apikey:
      type: apiKey
      description: Api Key based authentication (apikey)
      name: Authorization
      in: header

````